StoryNine/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
]

homepage/urls.py
from django.urls import path, include
from django.conf.urls import url
from . import views

app_name = 'homepage'

urlpatterns = [
    path('', views.index, name='index'),
    path('API/BookLikes', views.countLike, name='LikeAPI'),
    path('API/TopBooks', views.topRated, name='TopAPI'),
]

homepage/models.py
from django.db import models

# Create your models here.
class Book(models.Model):
    ID = models.CharField(primary_key=True, max_length=100)
    # Identifier = models.CharField()
    # Cover = models.CharField()
    # Title = models.CharField()
    # Author = models.CharField()
    # Publisher = models.CharField()
    # PDate = models.CharField()
    Likes = models.PositiveIntegerField(default=1)

    def __str__(self):
        return f"{self.ID}"

homepage/forms.py
from django import forms
from .models import Book

class LikeBook(forms.ModelForm):
    class Meta:
        model = Book
        fields = {
            'ID',
            # 'Identifier',
            # 'Cover',
            # 'Title',
            # 'Author',
            # 'Publisher',
            # 'PDate'
        }

homepage/views.py
from django.shortcuts import render, redirect
from django.contrib import messages
from django.core import validators, serializers
from django.urls import reverse
from django.http import JsonResponse

from .forms import LikeBook
from .models import Book

# Create your views here.
def index(request):
    context = {
        'nav': [
            [reverse('homepage:index'), 'Home'],
            ['https://story5ppw-achmadafriza.herokuapp.com/', 'About Me'],
        ]
    }
    return render(request, 'homepage.html', context)

def countLike(request):
    if request.is_ajax and request.method == "GET":
        try:
            book = Book.objects.get(ID=request.GET.get('ID'))

            obj = serializers.serialize('json', [book, ])
            return JsonResponse({"valid": True, "response": obj}, status=200)
        except Book.DoesNotExist:
            return JsonResponse({"valid": False}, status=200)
        
        # some error occured
        return JsonResponse({"error": ""}, status=400)

    elif request.is_ajax and request.method == "POST":
        try:
            book = Book.objects.get(ID=request.POST.get('ID'))
            book.Likes += 1
            book.save()

            obj = serializers.serialize('json', [book, ])
            return JsonResponse({"response": obj}, status=200)
        except Book.DoesNotExist:
            form = LikeBook(request.POST)
            if form.is_valid():
                form.save()

                book = Book.objects.get(ID=request.POST.get('ID'))
                obj = serializers.serialize('json', [book, ])
                return JsonResponse({"response": obj}, status=200)
            else:
                # some form errors occured.
                return JsonResponse({"error": form.errors}, status=400)
    
    # some error occured
    return JsonResponse({"error": ""}, status=400)

def topRated(request):
    bookCount = Book.objects.count()
    cutoff = Book.objects.order_by('-Likes')[min(5, bookCount)-1].Likes
    books = Book.objects.filter(Likes__gte=cutoff).order_by('-Likes').values()

    return JsonResponse({"response": list(books), 'count': bookCount-1}, status=200)

homepage/templates/booksearch.html
{% load static %}

<script type="text/javascript">
$("#searchform").submit(function(e) {
    e.preventDefault()

    var query = $(this).find(".statusform").val()
    if(query.length == 0) {
        $("#booktable").css("display", "none")
    }
    else {
        $.ajax({
            url: "https://www.googleapis.com/books/v1/volumes?q=" + query,
            success: function(data) {
                $("#booktable-content").empty()
                if(data.totalItems == 0) {
                    $("#booktable").css("display", "none")
                }
                else {
                    $("#booktable").css("display", "table")
                    var content = ""
                    for(var i = 0; i < data.items.length; i++) {
                        content += "<tr>"
                        
                        var Identifier
                        try {
                            Identifier = data.items[i].volumeInfo.industryIdentifiers[0].identifier
                        } catch(TypeError) {
                            Identifier = "Not Available"
                        } finally {
                            content += `<td class='align-middle'>${Identifier}</td>`
                        }

                        var Cover
                        try {
                            Cover = `<img src='${data.items[i].volumeInfo.imageLinks.thumbnail}'></img>`
                        } catch(TypeError) {
                            Cover = "Not Available"
                        } finally {
                            content += `<td class='align-middle'>${Cover}</td>`
                        }

                        var Id = data.items[i].id
                        var Title = data.items[i].volumeInfo.title
                        var Author = data.items[i].volumeInfo.authors
                        var Publisher = data.items[i].volumeInfo.publisher
                        var PDate = data.items[i].volumeInfo.publishedDate
                        
                        content += `<td class='align-middle'>${Title}</td>`
                        content += `<td class='align-middle'>${Author}</td>`
                        content += `<td class='align-middle'>${Publisher}</td>`
                        content += `<td class='align-middle'>${PDate}</td>`

                        $.ajax({
                            async: false,
                            type: 'GET',
                            url: "{% url 'homepage:LikeAPI' %}",
                            data: {'ID': Id},
                            success: function(response) {
                                // console.log(Id)
                                // console.log(response)
                                if(response['valid']) {
                                    var likes = JSON.parse(response["response"])[0]['fields']['Likes']
                                    content += `<td class='align-middle review-number'>${likes}</td>`
                                } else {
                                    content += `<td class='align-middle review-number'>0</td>`
                                }
                            }
                        })
                        content += `<td class='align-middle'>
                        <form class="formlike" method="POST" action="{% url 'homepage:LikeAPI' %}">
                            {% csrf_token %}
                            <input type="hidden" name="ID" value="${Id}">
                            <label>
                                <input type="submit" style="display: none;">
                                <svg type="submit" class="icons hvr-pop button-like" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="white" width="18px" height="18px"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M1 21h4V9H1v12zm22-11c0-1.1-.9-2-2-2h-6.31l.95-4.57.03-.32c0-.41-.17-.79-.44-1.06L14.17 1 7.59 7.59C7.22 7.95 7 8.45 7 9v10c0 1.1.9 2 2 2h9c.83 0 1.54-.5 1.84-1.22l3.02-7.05c.09-.23.14-.47.14-.73v-2z"/></svg>
                            </label>
                        </form>
                        </td>`
                        content += "</tr>"

                        /**
                         * <input type="hidden" name="Identifier" value="${Identifier}">
                            <input type="hidden" name="Cover" value="${Cover}">
                            <input type="hidden" name="Title" value="${Title}">
                            <input type="hidden" name="Author" value="${Author}">
                            <input type="hidden" name="Publisher" value="${Publisher}">
                            <input type="hidden" name="PDate" value="${PDate}">
                         */
                    }
                    
                    $("#booktable-content").append(content)
                }
            },
        })
    }
})
</script>

homepage/templates/homepage.html
<!doctype html> {% load static %}
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Montserrat:400,500,500i,600,600i,700,800i|Open+Sans:400,600&display=swap" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{% static 'css/base.css' %}">

    <title>Afriza's StoryNine</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/homepage.css' %}">
</head>

<body>
    {% include 'snippets/navbar.html' %}
    <div class="wrapper">
        <div class="content">
            <div id="Status" class="flex-centered">
                <div style="margin-bottom: 1.5vh;">
                    <h2>Maybe, Search a <span class="orange-text">Book</span>?</h2>
                    <button type="button" id="toprated" class="btn btn-primary" data-toggle="modal" data-target="#myModal">
                        Top-5 Rated Books
                    </button>
                    <form id="searchform">
                        <input type="text" name="search" placeholder="1001 Ways to Ruin your Life" class="statusform">

                        <button class="btn btn-primary">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="white" width="23px" height="23px"><path d="M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"/><path d="M0 0h24v24H0z" fill="none"/></svg>
                        </button>
                    </form>
                </div>
                <div class="status-wrapper">
                    <table id="booktable" class="table table-striped table-dark" style="display: none;">
                        <thead id="booktable-header">
                          <tr>
                            <th scope="col">Identifier</th>
                            <th scope="col">Cover</th>
                            <th scope="col">Title</th>
                            <th scope="col">Author</th>
                            <th scope="col">Publisher</th>
                            <th scope="col">Date</th>
                            <th scope="col">Rating</th>
                            <th scope="col"></th>
                          </tr>
                        </thead>
                        <tbody id="booktable-content"></tbody>
                    </table>
                </div>
            </div>
        </div>

        <!-- Modal -->
        <div id="myModal" class="modal fade" role="dialog">
            <div class="modal-dialog modal-lg">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" style="color: black;">Top 5 of All-Time</h4>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <div class="table-responsive">
                            <table id="modaltable" class="table table-borderless" style="border-radius: 15px;">
                                <thead id="modaltable-header">
                                  <tr>
                                    <th scope="col">Identifier</th>
                                    <th scope="col">Cover</th>
                                    <th scope="col">Title</th>
                                    <th scope="col">Author</th>
                                    <th scope="col">Publisher</th>
                                    <th scope="col">Date</th>
                                    <th scope="col">Rating</th>
                                    <th scope="col"></th>
                                  </tr>
                                </thead>
                                <tbody id="modaltable-content"></tbody>
                            </table>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                    </div>
                </div>

            </div>
        </div>

    </div>


    <!-- <a href="#Status"><svg class="button-down" xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0z" fill="none"/><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 12l-4-4h8l-4 4z" fill="#FFFFFF"/></svg></a> -->
    <!-- <a href="#Header"><svg class="button-up" xmlns="http://www.w3.org/2000/svg" height="24" viewBox="0 0 24 24" width="24"><path d="M0 0h24v24H0z" fill="none"/><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 12l-4-4h8l-4 4z" fill="#FFFFFF"/></svg></a> -->
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script> -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <!-- <script src="{% static 'js/booksearch.js' %}"></script> -->
    {% include 'booksearch.html' %}
    {% include 'likebutton.html' %}
    {% include 'toprated.html' %}
</body>

</html>

homepage/templates/likebutton.html
{% load static %}
<script type="text/javascript">
    $("html").on('click', '.formlike', function(e) {
        e.preventDefault()
        var form = $(this)
        var Id = $(this).find("input[name=ID]").val()
        var csrf = $(this).find("input[name=csrfmiddlewaretoken]").val()
        $.ajax({
            type: 'POST',
            url: "{% url 'homepage:LikeAPI' %}",
            data: {
                'ID': Id,
                'csrfmiddlewaretoken': csrf
            },
            success: function(response) {
                var likes = JSON.parse(response["response"])[0]['fields']['Likes']
                $(form).closest("tr").find(".review-number").text(likes)
            }
        })
    })
</script>

homepage/templates/snippets/navbar.html
{% load static %}

<header>
    <nav id="Navbar" class="navbar navbar-expand-lg navbar-dark">
        <div class="navbar-header">
            <a class="navbar-brand" href="{% url 'homepage:index' %}">
                <h4>Afriza's <span class="orange-text">StoryNine</span></h4>
            </a>
            <button id="NavbarHeaderButton" class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
            </button>
        </div>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mr-auto">
                {% for link,name in nav%}
                <li class="nav-item">
                    <a class="nav-link" href="{{link}}">{{name}}</a>
                </li>
                {% endfor %}
            </ul>
        </div>
    </nav>
</header>

homepage/templates/toprated.html
{% load static %}
<script type="text/javascript">
$("#toprated").on('click', function(e) {
    e.preventDefault()
    $.ajax({
        url: "{% url 'homepage:TopAPI' %}",
        success: function(response1) {
            $("#modaltable-content").empty()
            var content = ""
            console.log(response1['response'])
            for(var i = 1; i <= response1['count']; i++) {                
                $.ajax({
                    async:false,
                    url: "https://www.googleapis.com/books/v1/volumes?q=" + response1['response'][i-1]['ID'],
                    success: function(data) {
                        console.log(data)
                        content += "<tr>"
                                
                        var Identifier
                        try {
                            Identifier = data.items[0].volumeInfo.industryIdentifiers[0].identifier
                        } catch(TypeError) {
                            Identifier = "Not Available"
                        } finally {
                            content += `<td class='align-middle'>${Identifier}</td>`
                        }

                        var Cover
                        try {
                            Cover = `<img src='${data.items[0].volumeInfo.imageLinks.thumbnail}'></img>`
                        } catch(TypeError) {
                            Cover = "Not Available"
                        } finally {
                            content += `<td class='align-middle'>${Cover}</td>`
                        }

                        var Id = data.items[0].id
                        var Title = data.items[0].volumeInfo.title
                        var Author = data.items[0].volumeInfo.authors
                        var Publisher = data.items[0].volumeInfo.publisher
                        var PDate = data.items[0].volumeInfo.publishedDate
                        
                        content += `<td class='align-middle'>${Title}</td>`
                        content += `<td class='align-middle'>${Author}</td>`
                        content += `<td class='align-middle'>${Publisher}</td>`
                        content += `<td class='align-middle'>${PDate}</td>`

                        content += `<td class='align-middle review-number'>${response1['response'][i-1]['Likes']}</td>`
                        content += `<td class='align-middle'>
                        <form class="formlike" method="POST" action="{% url 'homepage:LikeAPI' %}">
                            {% csrf_token %}
                            <input type="hidden" name="ID" value="${Id}">
                            <label>
                                <input type="submit" style="display: none;">
                                <svg type="submit" class="icons hvr-pop button-like" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="black" width="24px" height="24px"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M1 21h4V9H1v12zm22-11c0-1.1-.9-2-2-2h-6.31l.95-4.57.03-.32c0-.41-.17-.79-.44-1.06L14.17 1 7.59 7.59C7.22 7.95 7 8.45 7 9v10c0 1.1.9 2 2 2h9c.83 0 1.54-.5 1.84-1.22l3.02-7.05c.09-.23.14-.47.14-.73v-2z"/></svg>
                            </label>
                        </form>
                        </td>`
                        content += "</tr>"
                    },
                })
            }

            $("#modaltable-content").append(content)
        }
    })
})
</script>